//Design schmitt trigger ckt using 2 silicon npn transistors with given config
//Windows 10
//Scilab 6.0.0

clc;
clear;
close;

UTP=5             //in volts
Vb2=5             //in volts
Vbe=0.7           //in volts
Vcc=12            //in volts
LTP=3             //in volts
Ic=2*10^-3       //in milli Amperes
Ic2=2*10^-3       //in milli Amperes
hfemin=100
UTP=Vb2
Ve=Vb2-Vbe
mprintf('\nVe:%.2f V',Ve)
Ie=Ic
Ie=Ie*10^3
mprintf('\nIe:%d mA',Ie)
Re=Ve/Ie
mprintf('\nRe:%.2f k ohms',Re)
//taking q2 saturated
Vcesat=0.2           //in volts
IcRc2=Vcc-Ve-Vcesat
mprintf('\nIcRc2:%.1f V',IcRc2)
Rc2=(Vcc-Ve-Vcesat)/Ic
Rc2=Rc2*10^-3
mprintf('\nRc2:%.2f k ohms',Rc2)
I2=0.1*Ic2
I2=I2*10^3
mprintf('\nI2:%.2f mA',I2)
R2=Vb2/I2
mprintf('\nR2:%d k ohms',R2)
Ib2=Ic2/hfemin
Ib2=Ib2*10^6
mprintf('\nIb2:%d uA',Ib2)
I1=I2+Ib2
//substituting the values and equating I1
//(Vcc-Vb2)/(Rc1+R1)=I1=0.2*10^-3+20*106-6
//12-5/(Rc1+R1)=0.22*10^-3
Rc1r1=(Vcc-Vb2)/I1
//Rc1+R1=7/(0.22*10^-3)
//when q1 is on Vi=LTP=Vb2=3v
Vi=LTP
Vb1=3
Vb2=3
I1=Vb2/R2
//I1=I1*10^3
mprintf('\nI1:%.2f mA',I1)
Ie=(Vb1-Vbe)/Re
Ic1=Ie
mprintf('\nIc1:%.2f mA',Ic1)
mprintf('\nIe:%.2f mA',Ie)

//Vcc=Rc1(Ic1+I1)+I1(R1+R2)
Rc1=(Vcc-I1*(Rc1r1+R2))/(Ie)
Rc1=Rc1*10^-3
R1=Rc1r1-Rc1
//Rb<hfeRe
Rb=(hfemin*Re)/10
mprintf('\nRb:%.2f k ohms',Rb)
